=== src/module/CMakeLists.txt ===
if (ENABLE_X11)
add_subdirectory(x11)
endif (ENABLE_X11)

if (ENABLE_X11 AND ENABLE_LIBXML2)
add_subdirectory(xkb)
endif (ENABLE_X11 AND ENABLE_LIBXML2)

if (_ENABLE_DBUS AND ENABLE_X11 AND ENABLE_LIBXML2)
    add_subdirectory(xkbdbus)
endif (_ENABLE_DBUS AND ENABLE_X11 AND ENABLE_LIBXML2)

add_subdirectory(chttrans)
add_subdirectory(punc)
add_subdirectory(spell)
add_subdirectory(pinyin-enhance)
add_subdirectory(quickphrase)
add_subdirectory(autoeng)
add_subdirectory(fullwidthchar)
add_subdirectory(remote)
add_subdirectory(imselector)
if (_ENABLE_CAIRO)
    add_subdirectory(vk)
endif (_ENABLE_CAIRO)

if (_ENABLE_DBUS)
    add_subdirectory(dbus)
endif (_ENABLE_DBUS)

if (ENABLE_LUA)
    add_subdirectory(lua)
endif (ENABLE_LUA)
add_subdirectory(unicode)
