=== debian/changelog ===
fcitx (1:4.2.6.1-2) experimental; urgency=low

  * Update debian/control
  * Fix build on GNU/Hurd.

 -- Aron Xu <aron@debian.org>  Sat, 01 Dec 2012 15:36:33 +0800

fcitx (1:4.2.6.1-1) experimental; urgency=low

  * New upstream bug fix release.

 -- Aron Xu <aron@debian.org>  Wed, 03 Oct 2012 22:33:51 +0800

fcitx (1:4.2.6-1) experimental; urgency=low

  * New upstream release. 

 -- YunQiang Su <wzssyqa@gmail.com>  Mon, 24 Sep 2012 20:16:40 +0800

fcitx (1:4.2.5-1~exp) experimental; urgency=low

  * New upstream release.

 -- YunQiang Su <wzssyqa@gmail.com>  Thu, 19 Jul 2012 19:25:18 +0800
